(ns example
  {:clj-kondo/config '{:lint-as {example/plet clojure.core/let}}}
  (:require ["puppeteer" :as puppeteer]))

(defmacro plet
  [bindings & body]
  (let [binding-pairs (reverse (partition 2 bindings))
        body (cons 'do body)]
    (reduce (fn [body [sym expr]]
              (let [expr (list '.resolve 'js/Promise expr)]
                (list '.then expr (list 'clojure.core/fn (vector sym)
                                        body))))
            body
            binding-pairs)))

;; This async code is much nicer with plet:
#_(-> (.launch puppeteer)
      (.then (fn [browser]
               (-> (.newPage browser)
                   (.then (fn [page]
                            (-> (.goto page "https://clojure.org")
                                (.then #(.screenshot page #js{:path "screenshot.png"}))
                                (.catch #(js/console.log %))
                                (.then #(.close browser)))))))))

(plet [browser (.launch puppeteer)
       page (.newPage browser)
       _ (.goto page "https://clojure.org")
       _ (-> (.screenshot page #js{:path "screenshot.png"})
             (.catch #(js/console.log %)))]
      (.close browser))

(plet [browser (.launch puppeteer)
       page (.newPage browser)]
      (.goto page "https://clojure.org")
      (-> (.screenshot page #js{:path "screenshot.png"})
          (.catch #(js/console.log %)))
      (.close browser))
